local version_time = "version_time";
DataCenter = nil;
local isInit = false;
NotiConst = nil;
function initDebug()
    --local breakInfoFun, xpcallFun = require("LuaDebug")("localhost", 7003);
end

function getLuaVersion()
    return "1.0.0.230713001"; -- 主版本.子版本.阶段版本.日期版本
end

function getCVersion() 
    if c_version == nil then
        c_version = tonumber(tostring(LanUtil.getValue(578)));
    end
    return c_version;
end

function getVersionStr()
    return version .. "." .. version_time;
end

-- 包号
function getPackNum()
    if DataCenter.roleData ~= nil and DataCenter.roleData.market > 0 then
        return DataCenter.roleData.market;
    end
    if market == nil then
        market = ServerConfig.market;
    end
    return market;
end

-- 渠道
function getChannelName()
    if channel == nil then
        channel = ServerConfig.channel;
    end
    return channel;
end

function initReflection()
    if DataCenter.initReflection == nil then
        DataCenter.initReflection = 1;
        require "tolua.reflection";
        tolua.loadassembly("Assembly-CSharp");
        tolua.loadassembly("mscorlib");
        if CommonUtil.isApplePlatform == false and CommonUtil.isGooglePlatform64 == false then
            if not Lua_PlatformUtil.IsWindowsEditor() or GlobalVar.luaDecodeType == 2 then
                tolua.loadassembly("work");
            end
        end
        local BindingFlags = require 'System.Reflection.BindingFlags'
    end
end

function initDefRequire()
    checkRequire("Time");
    checkRequire("coroutine");
    checkRequire("Array");
    checkRequire("ProtoPublic_pb");
    checkRequire("Lua_EventOwner");
    checkRequire("Lua_DisplayObject");
    checkRequire("Lua_Window");
    checkRequire("Lua_ColorDefine");
    checkRequire("Lua_AxisDefine");
    checkRequire("Lua_WinParam");
    checkRequire("Lua_WindowUtil");
    checkRequire("Lua_PlatformUtil");
    checkRequire("Lua_CommonUtil");
    checkRequire("Lua_BitOperation");
    checkRequire("Lua_TimeTransform");
    -- checkRequire("Lua_SocketManager");
    checkRequire("Lua_LoadFileType");
    checkRequire("Lua_DragContainer");
    checkRequire("Lua_DragList");
    checkRequire("Lua_ProxyManager");
    checkRequire("Lua_Rectangle");
    checkRequire("uilang");
    checkRequire("Lua_StringArray");
    checkRequire("Lua_SDKInterface");
    checkRequire("Lua_GameFindObjUtil");
end

function initLua()
    initDefRequire()
    DataCenter = {};
    DataCenter.bConfigLoaded = false;
    DataCenter.bCameraDragRange = false;
    DataCenter.sdkInterface = Lua_SDKInterface.new();
    DataCenter.gameFindObjUtil = Lua_GameFindObjUtil.new();
    LuaUtil.setSceneDataExtendVal("FurEffShow", false);

    -- window层级
    Lua_MainWinDefine =
    {
        BASE_LAYER = MainWinDefine.BASE_LAYER; -- 主菜单层 500
        NEW_TIPS_LAYER = MainWinDefine.NEW_TIPS_LAYER; -- 智能提示层 1000
        MAIN_WINDOW_LAYER = MainWinDefine.MAIN_WINDOW_LAYER; -- 低于主菜单栏之下窗口层 1500
        MAIN_MENU_LAYER = MainWinDefine.MAIN_MENU_LAYER; -- 主菜单栏窗口层 2500
        MAIN_MENU_TOP_LAYER = MainWinDefine.MAIN_MENU_TOP_LAYER; -- 高于主菜单栏窗口层 3500
        NORMAL_WINDOW_LAYER = MainWinDefine.NORMAL_WINDOW_LAYER; -- 一级窗口层 4500
        NORMAL_TOP_LAYER = MainWinDefine.NORMAL_TOP_LAYER; -- 二级窗口层 5500
        TIPS_WINDOW_LAYER = MainWinDefine.TIPS_WINDOW_LAYER; -- 提示窗口 6500
        GUIDE_WINDOW_LAYER = MainWinDefine.GUIDE_WINDOW_LAYER; -- 引导窗口 7000
        MAX_TOP_LAYER = MainWinDefine.MAX_TOP_LAYER; -- 最顶层窗口 7500
        MASK_LAYER = MainWinDefine.MASK_LAYER; -- 遮罩层 8500
    };

    -- Lua_SocketManager.getInstace():init();
    Lua_ColorDefine.initColor();
    Lua_ProxyManager.initProxy();
    initComponentStyle();
    isInit = true;
end

function initComponentStyle()
    -- C#已添加 这里方便查看
    -- UICreate.addStyle(1, "4287323700", "ui_common_button_001_n", "ui_common_button_001_n"); -- 8B5E34
    -- UICreate.addStyle(2, "4286867025", "ui_common_toggle_001_b", "ui_common_toggle_001_f"); -- 846651
    -- UICreate.addStyle(3, "4286212703", "ui_common_button_008_n", "ui_common_button_008_n"); -- 7A6A5F
    UICreate.addStyle(4, "4287323700", "ui_common_button_006_n", "ui_common_button_006_n"); -- 8B5E34
    UICreate.addStyle(5, "4287323700", "ui_common_button_007_n", "ui_common_button_007_n"); -- 8B5E34
    UICreate.addStyle(6, "4286151033", "ui_common_button_008_d", "ui_common_button_008_d"); -- 797979
    UICreate.addStyle(7, "4286212703", "ui_common_button_009_n", "ui_common_button_009_n"); -- 7A6A5F
    UICreate.addStyle(8, "4286867025", "ui_yxsd_toggle_001_f", "ui_yxsd_toggle_001_b"); -- 846651
    UICreate.addStyle(9, "4286867025", "ui_djc_toggle_001_b", "ui_djc_toggle_001_f"); -- 846651
    UICreate.addStyle(10, "4286212703", "ui_common_button_044_n", "ui_common_button_044_n"); -- 7A6A5F
    UICreate.addStyle(11, "4282204751", "ui_common_button_042_n", "ui_common_button_042_n"); -- 3D424F
    UICreate.addStyle(12, "4286867025", "ui_common_toggle_003_b", "ui_common_toggle_003_f"); -- 846651
    UICreate.addStyle(13, "4282204751", "ui_common_button_055_n", "ui_common_button_055_n"); -- 3D424F

    UICreate.addStyle(14, "4287582499", "xui_common_button_010", "xui_common_button_010"); -- 8F5123
    UICreate.addStyle(15, "4287582499", "xui_common_button_006_n", "xui_common_button_006_n"); -- 8F5123
    UICreate.addStyle(16, "4285882704", "xui_common_button_007_n", "xui_common_button_007_n"); -- 756150
    UICreate.addStyle(17, "4285229931", "xui_common_button_006_d", "xui_common_button_006_d"); -- 6B6B6B
end

function addLuaWindow()
    initLua();
end

function setWindowTable(winName)
    local c = checkRequire(winName);
    local win = c.new();
    win.windowName = winName;
    WindowMananger.getInstance():setWinTable(winName, win);
end

function openWin(winName, win, winRoot)
    if win ~= nil then
        win:buildPanel(winRoot);
    end
end

function closeWin(win)
    win:dispose();
end

-- local aaa = 0;
-- function onEnterFrame()
--     if isInit ~= true then
--         return;
--     end

--     DataCenter.frameStartTime = getTime();
--     Lua_CommonUtil.frameScript();
--     Lua_MsgUtil.checkRemoveEvent();
--     if DataCenter.frameStartTime - aaa > 30 then
--         aaa = DataCenter.frameStartTime;
--         LuaGC();
--     end
-- end

local gcTime = 30;
local gcIntervalTime = 30;
local isGc = false;
function onEnterFrame()
    if isInit ~= true then
        return;
    end

    DataCenter.frameStartTime = getTime();
    Lua_CommonUtil.frameScript();
    Lua_MsgUtil.checkRemoveEvent();
    if isGc == true then
        -- local c = collectgarbage("count")
        -- print("回收前collectgarbage count = " .. c.. " kb");
        if collectgarbage("step", 256) == true then
            isGc = false;
            gcTime = DataCenter.frameStartTime + gcIntervalTime;
            -- c = collectgarbage("count")
            -- print("回收后collectgarbage count = " .. c.. " kb");
        end
    else
        if DataCenter.frameStartTime > gcTime then
            isGc = true;
        end
    end    
end

function sendMsg(msgid, msg, socketType)
    if msg ~= nil then
        local pb_data = msg:SerializeToString();
        ProtolBuffer.data = pb_data;
    end
    ProtolBuffer.msgid = msgid;
    if socketType == nil then
        socketType = 1;
    end
    LuaUtil.sendSocket(socketType);
end

function clearLua(bReconnect)
    if bReconnect ~= true then
        if DataCenter.bConfigLoaded then
            PlayerData.instance.data.sceneId = 0;
            CameraControl.Instance:SetFollowTarget(nil);
            ThingUtil.instance:removeAll(0);
            Scene3DManager.instance:destoryAllScene();
        end
        UploadManager.getInstance():dispose();
    end

    Lua_WindowUtil.clearAllWinData();
    if DataCenter ~= nil then
        Lua_CommonUtil.clearAllTimer();
        -- Lua_SocketManager.getInstace():dicconnectAll();
        for k, v in pairs(DataCenter) do
            if type(v) == "table" and v.dispose ~= nil then
                v:dispose(bReconnect);
            end
        end
    end
end