Lua_ColorDefine = { };
Lua_ColorDefine.TYPE_WHITE = 1;
Lua_ColorDefine.TYPE_GREEN = 2;
Lua_ColorDefine.TYPE_BLUE = 3;
Lua_ColorDefine.TYPE_PURPLE = 4;
Lua_ColorDefine.TYPE_ORANGE = 5;
Lua_ColorDefine.TYPE_RED = 6;

function Lua_ColorDefine.initColor()
    Lua_ColorDefine.maxAlpha = tonumber("FF000000", 16);

    -- 白
    Lua_ColorDefine.WHITE_STR = "FFFFFF";
    Lua_ColorDefine.WHITE = Lua_ColorDefine.transColor("FFFFFF");

    Lua_ColorDefine.WHITE_STR_2 = "FFFFFF";
    Lua_ColorDefine.WHITE_2 = Lua_ColorDefine.transColor("FFFFFF");

    -- 绿
    Lua_ColorDefine.GREEN_STR = "459252";
    Lua_ColorDefine.GREEN = Lua_ColorDefine.transColor("459252");

    Lua_ColorDefine.GREEN_STR_2 = "459252";
    Lua_ColorDefine.GREEN_2 = Lua_ColorDefine.transColor("459252");

    -- 蓝
    Lua_ColorDefine.BLUE_STR = "159EC5";
    Lua_ColorDefine.BLUE = Lua_ColorDefine.transColor("159EC5");

    Lua_ColorDefine.BLUE_STR_2 = "159EC5";
    Lua_ColorDefine.BLUE_2 = Lua_ColorDefine.transColor("159EC5");

    -- 紫
    Lua_ColorDefine.PURPLE_STR = "C616B7";
    Lua_ColorDefine.PURPLE = Lua_ColorDefine.transColor("C616B7");

    Lua_ColorDefine.PURPLE_STR_2 = "C616B7";
    Lua_ColorDefine.PURPLE_2 = Lua_ColorDefine.transColor("C616B7");

    -- 橙
    Lua_ColorDefine.ORANGE_STR = "DE6D29";
    Lua_ColorDefine.ORANGE = Lua_ColorDefine.transColor("DE6D29");

    Lua_ColorDefine.ORANGE_STR_2 = "DE6D29";
    Lua_ColorDefine.ORANGE_2 = Lua_ColorDefine.transColor("DE6D29");

    -- 红
    Lua_ColorDefine.RED_STR = "ED6E30";
    Lua_ColorDefine.RED = Lua_ColorDefine.transColor("ED6E30");

    Lua_ColorDefine.RED_STR_2 = "ED6E30";
    Lua_ColorDefine.RED_2 = Lua_ColorDefine.transColor("ED6E30");
end

function Lua_ColorDefine.transColorStr(color, alpha)
    return tostring(Lua_ColorDefine.transColor(color, alpha));
end

function Lua_ColorDefine.transColor(color, alpha)
    local alphaVal = Mathf.Ceil(Lua_ColorDefine.maxAlpha * (alpha == nil and 1 or alpha));
    local colorVal = tonumber(color, 16)
    return alphaVal + colorVal;
end

function Lua_ColorDefine.getColorStr(color, str)
    return spliceStr("<color=#", color, ">", str, "</color>");
end

function Lua_ColorDefine.getColorName(colorType)
    return LanUtil.getValue(109000 + colorType - 1);
end

function Lua_ColorDefine.getItemColor(colorType, dark)
    if colorType == 1 then
        if dark == true then
            return Lua_ColorDefine.WHITE_2;
        else
            return Lua_ColorDefine.WHITE;
        end
    elseif colorType == 2 then
        if dark == true then
            return Lua_ColorDefine.GREEN_2;
        else
            return Lua_ColorDefine.GREEN;
        end
    elseif colorType == 3 then
        if dark == true then
            return Lua_ColorDefine.BLUE_2;
        else
            return Lua_ColorDefine.BLUE;
        end
    elseif colorType == 4 then
        if dark == true then
            return Lua_ColorDefine.PURPLE_2;
        else
            return Lua_ColorDefine.PURPLE;
        end
    elseif colorType == 5 then
        if dark == true then
            return Lua_ColorDefine.ORANGE_2;
        else
            return Lua_ColorDefine.ORANGE;
        end
    elseif colorType == 6 then
        if dark == true then
            return Lua_ColorDefine.RED_2;
        else
            return Lua_ColorDefine.RED;
        end
    else
        if dark == true then
            return Lua_ColorDefine.WHITE_2;
        else
            return Lua_ColorDefine.WHITE;
        end
    end
end

function Lua_ColorDefine.getItemColorStr(colorType, dark)
    if colorType == 1 then
        if dark == true then
            return Lua_ColorDefine.WHITE_STR_2;
        else
            return Lua_ColorDefine.WHITE_STR;
        end
    elseif colorType == 2 then
        if dark == true then
            return Lua_ColorDefine.GREEN_STR_2;
        else
            return Lua_ColorDefine.GREEN_STR;
        end
    elseif colorType == 3 then
        if dark == true then
            return Lua_ColorDefine.BLUE_STR_2;
        else
            return Lua_ColorDefine.BLUE_STR;
        end
    elseif colorType == 4 then
        if dark == true then
            return Lua_ColorDefine.PURPLE_STR_2;
        else
            return Lua_ColorDefine.PURPLE_STR;
        end
    elseif colorType == 5 then
        if dark == true then
            return Lua_ColorDefine.ORANGE_STR_2;
        else
            return Lua_ColorDefine.ORANGE_STR;
        end
    elseif colorType == 6 then
        if dark == true then
            return Lua_ColorDefine.RED_STR_2;
        else
            return Lua_ColorDefine.RED_STR;
        end
    else
        if dark == true then
            return Lua_ColorDefine.WHITE_STR_2;
        else
            return Lua_ColorDefine.WHITE_STR;
        end
    end
end

-- 广播道具色值
function Lua_ColorDefine.getBroadcastColorStr(colorType)
    if colorType == 1 then
        return "FFFFFF";
    elseif colorType == 2 then
        return "459252";
    elseif colorType == 3 then
        return "159EC5";
    elseif colorType == 4 then
        return "C616B7";
    elseif colorType == 5 then
        return "DE6D29";
    elseif colorType == 6 then
        return "E01B1B";
    else
        return "FFFFFF";
    end
end