-- 进度条加载页
Lua_LoadingScreenWindow = class("Lua_LoadingScreenWindow", Lua_Window);
function Lua_LoadingScreenWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.MAX_TOP_LAYER;
	self.windowName = "Lua_LoadingScreenWindow";
	self.isFullSizeWin = true;
    self.isFullSizeBg = true
	self.showWinBg = true;
	self.winBgPath = "/images/loading/login_bg.jpg";
end

function Lua_LoadingScreenWindow:buildPanel(go)
	self:superCall("buildPanel", go);
    self:addCSharpEvent("FIEL_VERSION_LOADED", self, self.onFielVersionLoaded);
end

function Lua_LoadingScreenWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsTxt = UICreate.createLabel(self.content, "", 0, 123, self.width, 31, 28);
    self.tipsTxt.name = "tipsTxt";
    self.tipsTxt.anchorValue = 7;
    self.tipsTxt.pivotValue = 4;
    self.tipsTxt.alignmentValue = 4;
    self.tipsTxt.effectStyle = 2;
    self.tipsTxt.effectColorStr = "4280624421";
    self.tipsTxt.colorStr = "4294967295";
    self.tipsTxt:setEffectDistance(2, 2);

    self.pb = UICreate.createProgressBar(self.content, "common_altas_1", "ui_dlcj_progress_001_b", "common_altas_1", "login_progress_001_f", 0, 79, self.width, 22);
    self.pb.anchorValue = 7;
    self.pb:createSlider("common_altas_1", "ui_xzjl_progress_001_m", -18, 0);
    self.pb:setMouseEnable(false);
    self.pb:setMaxValue(500);
    self.pb:setValue(100);
    self.pb:setText("");

    self.proTxt = UICreate.createLabel(self.content, "", 0, 80, self.width, 27, 22);
    self.proTxt.name = "proTxt";
    self.proTxt.anchorValue = 7;
    self.proTxt.pivotValue = 4;
    self.proTxt.alignmentValue = 4;
    self.proTxt.effectStyle = 2;
    self.proTxt.effectColorStr = "4280687680";
    self.proTxt.colorStr = "4294967295";
    self.proTxt:setEffectDistance(1, 1);

    self.tipsTxt:setEnable(false);
end

function Lua_LoadingScreenWindow:dispose()
	self:superCall("dispose");
end

function Lua_LoadingScreenWindow:showWin(param)
	self:superCall("showWin", param);

    if param == nil then
        param = Lua_LoadingScreenData.instance;
        if param == nil then
            return;
        end
    end

    if self.pb ~= nil then
        self.pb:setMaxValue(param.maxValue);
        self.pb:setValue(param.curValue);
    end

    local per = 1;
    if param.maxValue > 0 then
        per = Mathf.Floor(param.curValue * 100 / param.maxValue);
    end
    if param.str ~= nil then
        self.proTxt.text = LanUtil.formateStr(param.str, per);
    else
        self.proTxt.text = LanUtil.StringProfile3(per, "%");
    end

    if GlobalVar.bShowLoadingWinBg == true then
        if param.ltype == Lua_LoadingScreenData.LOADING_CODE or param.ltype == Lua_LoadingScreenData.LOADING_RES then
            if self._lastBg == nil then
                self.winBgPath = "/images/loading/" .. PlayerData.instance.phpData:getLoadingScreensStrByIdx(0);
                self._lastBg = self.winBgPath;
                self.winBg:setUrl(self.winBgPath, 99);
            end
            self.winBg:setEnable(true);
            self.tipsTxt:setEnable(false);
        elseif param.ltype == Lua_LoadingScreenData.LOADING_NOR then
            if LuaUtil.setRandomLoadingTipsShow(self.tipsTxt) == true then
                self.tipsTxt:setEnable(true);
            end

            if self._lastBg == nil then
                local str = PlayerData.instance.phpData:getLoadingScreensRandomStr();
                self._lastBg = "/images/loading/" .. str;
                self.winBgPath = self._lastBg;
                self.winBg.setUrl(self._lastBg, 99);
            end
            self.winBg.setEnable(true);
        end
    elseif param.ltype == Lua_LoadingScreenData.LOADING_LOGIN then
        self.winBg:setEnable(false);
        if LuaUtil.setRandomLoadingTipsShow(self.tipsTxt) == true then
            self.tipsTxt:setEnable(true);
        end
    else
        self.winBg:setEnable(false);
        self.tipsTxt:setEnable(false);
    end
end

function Lua_LoadingScreenWindow:onFielVersionLoaded(obj)
    local url = self.winBg.url;
    self.winBg:clearTexture();
    self.winBg:clearLoadRes();
    self.winBg:setUrl(url);
end