-- 创角界面
Lua_CreateRoleWindow = class("Lua_CreateRoleWindow", Lua_Window);
function Lua_CreateRoleWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_CreateRoleWindow";
    self.skinName = "CreateRoleWindow_skin";
    self.openSound = "";
    self.closeSound = "";
    self.showWinBg = true;
    self.isFullSizeWin = true;
    self.isSingleShowWin = true;
    self.winBgPath = "/images/loading/ui_dlcj_bj_001.jpg";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);

    -- self.winSceneId = Lua_SceneDefine.CREATEROLE;
    self.lastTime = 0;
    self.isRotState = false;
    self.startDir = 0;
    self.startMousePosX = 0;
    self._gender = 0;
end

function Lua_CreateRoleWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.des:setLangValue(123722);

    local nameLimit = Lua_CommonUtil.getCommonConfig("name_character_limit", 3)
    self.txtInput.characterLimit = nameLimit[2];
    self.txtInput.bCheckChinese = true;
    -- self.txtInput:addValidateInfo('A', 'Z');
    -- self.txtInput:addValidateInfo('a', 'z');
    -- self.txtInput:addValidateInfo('0', '9');
    self.txtInput:setDefaultLangValue(123723)

    self:addLuaEvent("BACK_RANDOM_NAME", self, self.updateRandomName);--更新随机名
    
    DataCenter.gameReported:loginReportedData(Lua_GameReported.ENTER_CREATEROLE_WIN);
    -- self.rotBg:addMousDownFuntion(self, self.onMouseDown);
    -- self.rotBg:addMouseUpFuntion(self, self.onMouseUp);
    self.startBtn:addClickFuntion(self, self.onStartBtnClick);--确定
    self.randomBtn:addClickFuntion(self, self.onRandomBtnClick);--随机
    self.changeBtn:addClickFuntion(self, self.onChangeBtnClick);--形象更换
    
    -- self.modelData = UsData();
    -- self.modelData.career = 1;
    -- self.modelData.gender = Lua_ThingDefine.MALE;
    -- self.modelData.nickname = "";
    -- self.modelData.hp = 1;
    -- self.modelData.maxHp = 1;
    -- self.modelData.kind = Lua_ThingDefine.PLAYER;
    -- self.modelData.isShowName = false;
    -- self.modelData.fashion_clothes_id = 0;
    -- self.modelData.fashionHeadId = 0;
    -- self.modelData.mustShow = true;
    -- self.modelData.sceneId = self.winSceneId;
    -- self.modelData.dir = -90;
    -- local sc = Lua_SceneConfigData.getSceneConfig(self.winSceneId);
    -- if sc.lookPos ~= nil then
    --     local pos = sc.lookPos;
    --     self.modelData.px = pos.x;
    --     self.modelData.py = pos.y;
    --     self.modelData.pz = pos.z;
    -- end
    -- self.playerModel = ThingUtil.instance:addAnimal(self.modelData, true);
    
    -- AudioUtil.playCreateRoleMusic();
    Lua_WindowUtil.openWin("LoginBgWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_ServerListWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_CLOSE);
    -- Lua_WindowUtil.openWin("Lua_CreateRoleAniShowWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_LoadingScreenWindow", Lua_WinParam.ACTION_CLOSE);

    self:updateGender(Lua_ThingDefine.MALE);
end

function Lua_CreateRoleWindow:dispose()
    self:onMouseUp();
    self.modelData= nil;
    self.playerModel = nil;
    self:superCall("dispose");
end

--更新形象
function Lua_CreateRoleWindow:updateGender(value)
    if self._gender ~= value then
        self._gender = value;
        local sprite = value == Lua_ThingDefine.MALE and "ui_dlcj_button_006_n" or "ui_dlcj_button_005_n";
        self.changeBtn:setAltas("login_atlas",sprite);

        local image = value == Lua_ThingDefine.MALE and "/images/loading/ui_dlcj_bj_004.png" or "/images/loading/ui_dlcj_bj_003.png";
        self.show_image:setUrl(image);
        self:onRandomBtnClick();
        -- self.modelData.gender = value;
        -- self.playerModel.data = self.modelData;
        -- self.playerModel:loadBody();
        -- self.playerModel.direction = -90;
    end
end

--更新随机名字
function Lua_CreateRoleWindow:updateRandomName(str)
    self.txtInput.text = str;
end

--形象更换
function Lua_CreateRoleWindow:onChangeBtnClick()
    if self._gender == Lua_ThingDefine.MALE then--男
        self:updateGender(Lua_ThingDefine.FEMALE);
    else--女
        self:updateGender(Lua_ThingDefine.MALE);
    end
end

function Lua_CreateRoleWindow:onStartBtnClick(go)
    local nameStr = self.txtInput.text;
    nameStr = string.gsub(nameStr, " ", "");
    nameStr = string.gsub(nameStr, "\n", "");
    nameStr = string.gsub(nameStr, "\r", "");
    
    if DataCenter.loginData:checkRoleNameIsInvalid(nameStr) then
        return;
    end

    local t = getTime();
    if t - self.lastTime < 3 then
        return;
    end
    self.lastTime = t;
    Lua_ProxyManager.getProxy("Lua_LoginProxy"):sCreateRole(nameStr, self._gender);
    DataCenter.gameReported:loginReportedData(Lua_GameReported.CLICK_CREATEROLE_BTN);
    Lua_MsgUtil.callFunc("TRG_SINGLE_GUIDE", DataCenter.guideUtil.create_role_gid2);
end

function Lua_CreateRoleWindow:onRandomBtnClick(go)
    Lua_ProxyManager.getProxy("Lua_LoginProxy"):onRandomName(self._gender);
end

function Lua_CreateRoleWindow:onMouseDown(go)
    if self.isRotState == false and self.playerModel ~= nil then
        self.isRotState = true;
        self.startDir = self.playerModel.direction;
        self.startMousePosX = CommonUtil.mousePositionX;
        Lua_CommonUtil.addTimer("onRoleRoting", 0.01, self, self.onRoleRoting);
    end
end

function Lua_CreateRoleWindow:onMouseUp(go)
    if self.isRotState == true then
        self.isRotState = false;
        Lua_CommonUtil.removeTimer(self, self.onRoleRoting);
    end
end

function Lua_CreateRoleWindow:onRoleRoting(dt)
    local gap = CommonUtil.mousePositionX - self.startMousePosX;
    if self.playerModel ~= nil then
        self.playerModel.direction = self.startDir + gap;
    end
end