-- 登录服务器列表
checkRequire("Lua_ServerListItem");
checkRequire("Lua_ServerTitleItem");
checkRequire("Lua_MyServerListItem");
Lua_ServerListWindow = class("Lua_ServerListWindow", Lua_Window);
function Lua_ServerListWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_ServerListWindow";
    self.skinName = "ServerListWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
    self.showClose = false;
    self.openSound = "";
    self.closeSound = "";
end

function Lua_ServerListWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	if self.titleList ~= nil then
		self.titleList:dispose();
		self.titleList = nil;
	end

	if self.myDragList ~= nil then
		self.myDragList:dispose();
		self.myDragList = nil;
	end

	self.serverData = nil;
    self:superCall("dispose");
end

function Lua_ServerListWindow:buildShowItem()
    self:superCall("buildShowItem");
    GlobalVar.isInGame = 0;

    self.showDes:setLangValue(123721);
    self.showDes:setEnable(false);

    self.dragList = Lua_DragList.new(self.content, 355, 684, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_ServerListItem, 355, 78, 1);
    self.dragList:setCellSpacing(5, 5);
    self.dragList:setLocation(127, -3);

    self.titleList = Lua_DragList.new(self.content, 233, 684, Lua_AxisDefine.Vertical);
    self.titleList:setListCell(Lua_ServerTitleItem, 224, 83, 1);
    self.titleList:setCellSpacing(6, 6);
    self.titleList:setLocation(-193, -3);

    self.myDragList = Lua_DragList.new(self.show_obj, 359, 634, Lua_AxisDefine.Vertical);
    self.myDragList:setListCell(Lua_MyServerListItem, 359, 110, 1);
    self.myDragList:setCellSpacing(3, 3);
    self.myDragList:setLocation(127, -28);


	self:addLuaEvent("SELECTE_SERVER", self, self.onSelectedServer);
	self:addLuaEvent("SELECTE_SERVER_INDEX", self, self.onSelectIndex);
    Lua_WindowUtil.openWin("Lua_StartWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_LoginWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_ServerListWindow:showWin(param)
    self:superCall("showWin", param);
    self.serverData = param;
    self:updateTitleList();
end

-- 更新左侧列表
function Lua_ServerListWindow:updateTitleList()
    if self.serverData ~= nil and self.serverData.allZoneList:getSize() > 0 then
        local idx = 0;
        if self.serverData.myServerList:getSize() > 0 then -- 选中我的服务器
            if self.serverData.recommendServerList:getSize() > 0 then
                idx = self.serverData.allZoneList[2].zone;
            else
                idx = self.serverData.allZoneList[1].zone;
            end
        elseif self.serverData.recommendServerList:getSize() > 0 then
            idx = self.serverData.allZoneList[1].zone;
        else
            if self.serverData.selectServerData ~= nil then
                idx = self.serverData.selectServerData.zone;
            else
            	local len = self.serverData.allZoneList:getSize();
                idx = self.serverData.allZoneList[len].zone;
            end
        end
        self.titleList:setArrayData(self.serverData.allZoneList);
        self:setSelectIndex(idx);
    end
end

function Lua_ServerListWindow:onSelectIndex(idx)
    self:setSelectIndex(idx);
end

function Lua_ServerListWindow:setSelectIndex(idx)
    if self.serverData == nil then
        return;
    end

    if self._selectIdx == nil or self._selectIdx ~= idx then
        self._selectIdx = idx;
        local len = self.serverData.allZoneList:getSize();
        for i = 1, len do -- 更新左侧标题选中
            local sd = self.serverData.allZoneList[i];
            if sd ~= nil then
            	sd.selected = sd.zone == idx; 
            end
        end
        self.titleList:updateShowList();

        self.show_obj:SetActive(false); -- 默认不显示

        local list = nil;
        if self._selectIdx == 0 then -- 自己服务器
            list = self.serverData.myServerList;
            list:sort("login_time", true);
            self.myDragList:setArrayData(list);
            self.dragList:setEnable(false);

            if list:getSize() > 0 then
                local lastLoginServerData = list[1];

                self.state:setAltas("login_atlas", lastLoginServerData:getStateIcon());

                self.sever_name.text = lastLoginServerData.name;
                self.show_obj:SetActive(true);
            end
        else
        	if self._selectIdx == -1 then
        		list = self.serverData.recommendServerList;
        	else
        		list = self.serverData.allServerDic[tostring(idx)]; -- 推荐服务器:其他服务器
            end

            list:sort("login_time", true);
            self.dragList:setArrayData(list);
            self.dragList:updateChildPos();
            self.dragList:setEnable(true);
        end

        local isShowNoneTip = list:getSize() <= 0;
        self.showDes:setEnable(isShowNoneTip);
    end
end

function Lua_ServerListWindow:onSelectedServer(obj)
    self.serverData.selectServerData = obj;
    self:hide();
end