-- 游戏数据上报
Lua_GameReported = class("Lua_GameReported");
Lua_GameReported.PHONE_DEVICE_INFO = 102; -- 设备信息
Lua_GameReported.SDK_LOGIN_SUCCESS = 103; -- sdk登录成功
Lua_GameReported.GET_SERVERLIST_SUCCESS = 104; -- 获取服务器列表成功
Lua_GameReported.ENTER_SERVERSELECT_WIN = 105; -- 进入选服界面
Lua_GameReported.LINK_SERVER_SOCKET = 106; --连接服务器socket
Lua_GameReported.LINK_SERVER_SOCKET_FAIL = 107; -- 连接服务器socket失败
Lua_GameReported.LOGIN_SERVER_VERIFY = 108; --登录前验证
Lua_GameReported.TIME_SERVER_SOCKET = 109; --连接服务器socket超过3s，3s内失败会重连
Lua_GameReported.ENTER_CREATEROLEANI_WIN = 110; --开场动画播放界面打开
Lua_GameReported.ENTER_CREATEROLE_WIN = 111; --创角界面打开
Lua_GameReported.CLICK_CREATEROLE_BTN = 112; --点击创角
Lua_GameReported.ENTER_GAME_SCENE = 113; --进入游戏；
function Lua_GameReported:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_GameReported:dispose()
	
end

--登录部分上报游戏数据
function Lua_GameReported:loginReportedData(pos)
	local postData = {
		func = "device",
		location = pos,
		package = ServerConfig.market,
		channel = ServerConfig.channel,
		account = ServerConfig.userID,
		mac = ServerConfig.mac,
		device = ServerConfig.device,
		sys_model = ServerConfig.sysModel,
		sys_version = ServerConfig.sysVersion
	};
    if LanUtil.IsNullOrEmpty(SDKInfo.CustomDevice) == false then
    	postData.custom_device = SDKInfo.CustomDevice;
    end
    local tokenstr = decodeTabToJson(postData);
    UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestReportUrl, tokenstr);
end

-- 获取后台客户端信息
-- clickType 1，用户协议；2，隐私政策；
-- function Lua_GameReported:getClientInfoByPhp(clickType)
--     local formData = {
--     	func = "baseClientConfig",
--     	package = tostring(ServerConfig.market),
--     	user_click = clickType
--     };
--     local tokenstr = decodeTabToJson(formData);
--     UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestReportUrl, tokenstr, tostring(clickType), self, self.onClientInfoLoaded, self.onClientInfoLoadErr, true);
-- end

-- function Lua_GameReported:onClientInfoLoaded(text, sign)
-- 	if text ~= nil and text ~= "" and sign ~= nil then
-- 		local dic = decodeJson(text);
-- 		if dic ~= nil then
-- 			local infoStr = nil;
-- 			local clickType = tonumber(tostring(sign));
-- 			if clickType == 1 then
-- 		        if dic.user_protocol ~= nil then
-- 		            infoStr = tostring(dic.user_protocol);
-- 		        end
-- 		    elseif clickType == 2 then
-- 		    	if dic.user_secret ~= nil then
-- 		            infoStr = tostring(dic.user_secret);
-- 		        end
-- 		    end

-- 		    if LanUtil.IsNullOrEmpty(infoStr) ~= true then
-- 		    	Lua_WindowUtil.openWin("Lua_UserProtocolWindow", Lua_WinParam.ACTION_OPEN, infoStr);
-- 		    end
-- 		end
-- 	end
-- end

-- function Lua_GameReported:onClientInfoLoadErr(text, sign)
--     LogManager.LogError("====== onClientInfoLoadErr ======"..text, true);
-- end

-- 上报玩家信息
function Lua_GameReported:UpdateCreateRole()
	if Lua_PlatformUtil.IsWindowsEditor() ~= true then
	    local data = DataCenter.roleData;
	    local arr = string.split(data.name, " ");
	    local nickName = arr:getSize() > 1 and arr[1] or arr[0];
	    arr = string.split(ServerConfig.serverName, " ");
	    local serverName = arr:getSize() > 1 and (arr[0] .. "-" .. arr[1]) or arr[0];

	    local dic = {};
	    dic.roleId = data.roleId;
	    dic.roleName = nickName;
	    dic.roleLevel = data.level;
		dic.zoneId = ServerConfig.serverId;
	    dic.zoneName = serverName;
	    dic.balance = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.DIAMOND);
	    dic.vip = data.vip;
	    dic.partyName = data.league_name;
	    dic.roleCTime = data.createRoleTime;
	    dic.fighting = data.force;
	    local playerInfo = decodeTabToJson(dic);
	    DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.CreateRole, playerInfo);
	end
end


-- 上报玩家信息
function Lua_GameReported:UpdatePlayerInfo()
	if Lua_PlatformUtil.IsWindowsEditor() ~= true then
	    local data = DataCenter.roleData;
	    local arr = string.split(data.name, " ");
	    local nickName = arr:getSize() > 1 and arr[1] or arr[0];
	    arr = string.split(ServerConfig.serverName, " ");
	    local serverName = arr:getSize() > 1 and (arr[0] .. "-" .. arr[1]) or arr[0];

	    local dic = {};
	    dic.roleId = data.roleId;
	    dic.roleName = nickName;
	    dic.roleLevel = data.level;
		dic.zoneId = ServerConfig.serverId;
	    dic.zoneName = serverName;
	    dic.balance = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.DIAMOND);
	    dic.vip = data.vip;
	    dic.partyName = data.league_name;
	    dic.roleCTime = data.createRoleTime;
	    dic.isCreateRole = DataCenter.loginData.isCreateRole;
	    dic.center_server = ServerConfig.center_server;
	    dic.fighting = data.force;
	    local playerInfo = decodeTabToJson(dic);
	    DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.UpdatePlayerInfo, playerInfo);
	end
end

-- 玩家等级上报
function Lua_GameReported:UpdateLevel(level)
	if Lua_PlatformUtil.IsAndroid() then
		print("等级提升--" .. level);
		local upDic = {};
	    local data = DataCenter.roleData;
		upDic.level = level;
		upDic.fighting = data.force;
		local playerInfo = decodeTabToJson(upDic);
		DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.UpdateLevel, playerInfo);
	elseif Lua_PlatformUtil.IsIPhonePlayer() then
		print("等级提升--" .. level);
		local upDic = {};
	    local data = DataCenter.roleData;
		upDic.roleLevel = level;
		upDic.fighting = data.force;
	    upDic.balance = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.DIAMOND);
	    upDic.vip = data.vip;
	    upDic.partyName = data.league_name;
	    local playerInfo = decodeTabToJson(upDic);
		DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.UpdateLevel, playerInfo);
	end
end