-- 登录创角动画dialog
Lua_DialogNormalShowPanel = class("Lua_DialogNormalShowPanel", Lua_DisplayObject);
function Lua_DialogNormalShowPanel:ctor(p)
	self:superCall("ctor", p, nil, true);
end

function Lua_DialogNormalShowPanel:buildShowItem()
	self:superCall("buildShowItem");

	local img = UICreate.createUIAtlasImage(self.content, "iconantlas2", "Begin_edit_001", 0, 0, 0, 0);
    img.siblingIndex = 3;

    self._txt = UICreate.createLabel(self.content, "", -130, 52, 260, 30, 20);
    self._txt.verticalOverflow = UnityEngine.VerticalWrapMode.Overflow;
    self._txt.lineSpacing = 1;
    self._txt.pivot = UIUtils.Pivot.TopLeft;
    self._txt.alignment = UnityEngine.TextAnchor.UpperLeft;
    self._txt.siblingIndex = 4;

    TweenUtil.getInstance():stop(self.content);
    LuaUtil.setObjScale(self.content, 0.1, 0.1, 0.1);
    TweenUtil.getInstance():addTweenTargetScale(self.content, 0.5, 0, 1, 1, 1, 0, false);
end

function Lua_DialogNormalShowPanel:dispose()
	TweenUtil.getInstance():stop(self.content);
	self:superCall("dispose");
end

function Lua_DialogBubblesShowPanel.Get:dialogType()
	return self._dialogType;
end

function Lua_DialogBubblesShowPanel.Set:dialogType(val)
	self._dialogType = val;
end

function Lua_DialogBubblesShowPanel.Get:dialogSpd()
	return self._dialogSpd > 0 and self._dialogSpd or 20;
end

function Lua_DialogBubblesShowPanel.Set:dialogSpd(val)
	self._dialogSpd = val > 0 and val or 20;
end

function Lua_DialogBubblesShowPanel.Get:dialogStr()
	return self._dialogStr;
end

function Lua_DialogBubblesShowPanel.Set:dialogStr(val)
	self._dialogStr = val;
end

function Lua_DialogBubblesShowPanel.Get:dialogColor()
	return self._dialogColor;
end

function Lua_DialogBubblesShowPanel.Set:dialogColor(val)
	self._dialogColor = val;
end

function Lua_DialogBubblesShowPanel.Get:dialogTime()
	return self._dialogTime;
end

function Lua_DialogBubblesShowPanel.Set:dialogTime(val)
	self._dialogTime = val;
	self._createTime = getTime();
end

function Lua_DialogBubblesShowPanel.Get:bCompleted()
	return self._bCompleted;
end

function Lua_DialogBubblesShowPanel.Set:bCompleted(val)
	self._bCompleted = val;
end

function Lua_DialogBubblesShowPanel:checkOverShowTime()
    local dt = (getTime() - self._createTime) * 1000;
    return self._dialogTime <= dt;
end

function Lua_DialogBubblesShowPanel:destory()
    self:dispose();
end

function Lua_DialogBubblesShowPanel:frameScript()
    if self.bCompleted then
        return;
    end

    if not LanUtil.IsNullOrEmpty(self.dialogStr) then
        local num = Mathf.Floor((getTime() - self._createTime) * 1000 / self.dialogSpd);
        num = num >= string.len(self.dialogStr) and -1 : num;
        if not LanUtil.IsNullOrEmpty(dialogColor) then
        	self._txt.text = LanUtil.StringProfile3("<color=#", self.dialogColor, ">", string.sub(self.dialogStr, 1, num), "</color>");
        else
            self._txt.text = string.sub(self.dialogStr, 1, num);
        end
    end
end

function Lua_DialogBubblesShowPanel:clickOverShow()
    if not LanUtil.IsNullOrEmpty(self.dialogColor) then
        self._txt.text = LanUtil.StringProfile3("<color=#", self.dialogColor, ">", self.dialogStr, "</color>");
    else
        self._txt.text = self.dialogStr;
    end
    self.bCompleted = true;
end