-- 登录模块
checkRequire("Lua_LoginData");
checkRequire("Lua_OneServerData");
checkRequire("Lua_ServerListData");
checkRequire("Lua_CreateRoleAniData");
checkRequire("Lua_WinTweenManager");
checkRequire("Lua_GameReported");
checkRequire("Lua_WinConfigData");
checkRequire("Lua_PopupWinManager");
Lua_LoginProxy = class("Lua_LoginProxy");
function Lua_LoginProxy:ctor()
	self:superCall("ctor");
    DataCenter.loginData = Lua_LoginData.new();
    DataCenter.gameReported = Lua_GameReported.new();
    DataCenter.createRoleAniData = Lua_CreateRoleAniData.new();
    DataCenter.winTweenManager = Lua_WinTweenManager.new();
    DataCenter.popupWinManager = Lua_PopupWinManager.new();

    LuaUtil.addLuaMsg(50100101, self, self.gatewayValReturn); --网关登陆验证
    LuaUtil.addLuaMsg(50100001, self, self.rLoginServer); -- 登录服务器
    LuaUtil.addLuaMsg(50100002, self, self.rRandomName); -- 随机名字返回
    LuaUtil.addLuaMsg(50100003, self, self.rCreateRole); -- 创建角色(返回)
    LuaUtil.addLuaMsg(50100004, self, self.rLoginRole); -- 选择角色登录(返回)
    LuaUtil.addLuaMsg(50100005, self, self.rServerInfo); -- 获取服务器信息
    LuaUtil.addLuaMsg(50100006, self, self.rHeart); -- 心跳包(返回)

    LuaUtil.addLuaMsg(80101001, self, self.rUpdatePlayerInfo); -- 玩家登录信息通知
    LuaUtil.addLuaMsg(80100001, self, self.rTopNumber); -- 通知顶号，不需要重连
    LuaUtil.addLuaMsg(80100002, self, self.rLoginServerFail); -- 通知客户端登录失败

    MsgUtil.addEventListener(EventsDefine.CONNECT_SUCCESS, self, self.onSocketConnectedSuccess); -- 成功连接
    MsgUtil.addEventListener(EventsDefine.CONNECT_FAIL, self, self.onSocketConnectedFail); --连接失败
    MsgUtil.addEventListener(EventsDefine.CONFIG_LOADED, self, self.onConfigLoaded);
    MsgUtil.addEventListener(EventsDefine.SCREEN_RESIZE, self, self.onScreenResize);
    MsgUtil.addEventListener(EventsDefine.RECONNECT, self, self.onReconnect);
    MsgUtil.addEventListener(EventsDefine.LOADINGSCREEN_BLACKGROUND_SHOW, self, self.onLoadingScreenShow); -- 加载背景显示完成
    MsgUtil.addEventListener(EventsDefine.LOADINGSCREEN_WINDOW_HIDE, self, self.onLoadingScreenHide); -- 加载界面关闭
    MsgUtil.addEventListener(EventsDefine.SINGLESER_UPDATE_END, self, self.onSingleSerUpdateEnd); -- 单服更新完成
    MsgUtil.addEventListener("VIDEOLODING_PLAYFRAME_EVENT", self, self.onVideoResErr); -- 视频播放资源出错
    MsgUtil.addEventListener("VIDEOLODING_RES_ERR", self, self.onVideoResErr); -- 视频播放资源出错
    MsgUtil.addEventListener("ESC_EIXT", self, self.onEscClick);

    Lua_MsgUtil.addEventListener("SCENE_LOADED", self, self.onSceneLoaded);
    Lua_MsgUtil.addEventListener("RECONNECT_SUCCESS", self, self.onReconnectSuccess);
    Lua_MsgUtil.addEventListener("SHOW_LOG_CHANGE", self, self.onShowLogChange);
    Lua_MsgUtil.addEventListener("SHOW_FPS", self, self.onShowFps);
    Lua_MsgUtil.addEventListener("GetAnnouncementServerInfo", self, self.onGetAnnouncement); -- 获取公告信息
	Lua_MsgUtil.addEventListener("LOGIN_BACK_SEVER_SELECTED", self, self.onPaltformLoginBack); -- sdk登录返回
    Lua_MsgUtil.addEventListener("SERVER_VALISOCKET_CONNECT", self, self.onLoginServerGate); -- 连接socket
    Lua_MsgUtil.addEventListener("STATE_RUNBACKGROUND_CHANGE", self, self.onRunInBackgroundChange);
end




---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 事件监听
-- socket连接成功
function Lua_LoginProxy:onSocketConnectedSuccess(bc)
    if bc == nil then
        return;
    end
    
    bc = tonumber(tostring(bc));
    if bc == Connection.VALIDATION_SOCKET then
        local msg = ProtoPublic_pb.Proto10100101();
        msg.account = ServerConfig.userID;
        msg.tick = ServerConfig.time;
        msg.session = ServerConfig.flag;
        msg.server_flag = ServerConfig.sign;
        sendMsg(10100101, msg, Connection.VALIDATION_SOCKET);
    elseif bc == Connection.MAIN_SOCKET then 
        DataCenter.loginData.isUpdatePlayerInfo = false;
        local msg = ProtoPublic_pb.Proto10100001();
        msg.account = ServerConfig.userID;
        msg.tick = ServerConfig.time;
        msg.session = ServerConfig.flag;
        msg.server_flag = ServerConfig.sign;
        msg.server_name = ServerConfig.real_server_name; -- 服务器器名字
        msg.agent = ServerConfig.channel; -- 渠道标识
        msg.market = ServerConfig.market;
        msg.net_type = SDKInfo.NetState;
        if SDKInfo.SystemVersion ~= nil then
            msg.sys_version = SDKInfo.SystemVersion;
        end
        if SDKInfo.PhoneModel ~= nil then
            msg.sys_model = SDKInfo.PhoneModel;
        end
        if SDKInfo.MACAddress ~= nil then
            msg.mac = SDKInfo.MACAddress;
        end
        if Lua_PlatformUtil.IsAndroid() then
            msg.client_type = 1;
        elseif Lua_PlatformUtil.IsIPhonePlayer() then
            msg.client_type = 2;
        else
            msg.client_type = 0;
        end
        msg.device = ServerConfig.device;
        msg.sdk_sid = ServerConfig.sId;
        sendMsg(10100001, msg);
    end
end

-- socket连接失败
function Lua_LoginProxy:onSocketConnectedFail(bc)
    if bc == nil then
        return;
    end

    bc = tonumber(tostring(bc));
    if bc == Connection.VALIDATION_SOCKET or bc == Connection.MAIN_SOCKET then
        self:loadServerListError();
    end
end

-- 公告
function Lua_LoginProxy:onGetAnnouncement(isClick)
    if DataCenter.loginData.announcementObj ~= nil and isClick == true then
        self:showAnnouncementWin();
        return;
    end

    local sign = "1";
    if isClick ~= true then
        sign = "0";
    end

    local formData = {
        func = "notice",
        package = ServerConfig.market
    };
    local tokenstr = decodeTabToJson(formData);
    UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestReportUrl, tokenstr, sign, self, self.loadAnnouncementComplete, nil, true);
end

function Lua_LoginProxy:loadAnnouncementComplete(text, sign)
    if LanUtil.IsNullOrEmpty(text) then
        return;
    end

    local obj = decodeJson(text);
    local bShowAnnouncement = false;
    DataCenter.loginData.announcementObj = obj;
    if obj ~= nil and obj.is_alert ~= nil then -- 后台控制自动弹出公告
        bShowAnnouncement = tonumber(tostring(obj.is_alert)) == 1;
    end

    if (sign ~= nil and sign == "1") or bShowAnnouncement == true then
        self:showAnnouncementWin(obj);
    end
end

function Lua_LoginProxy:showAnnouncementWin(obj)
    if obj == nil then
        obj = DataCenter.loginData.announcementObj;
    end

    if obj == nil then
        return;
    end

    if Lua_WindowUtil.isWindowShowing("CreateRoleAniShowWindow") ~= true then
        Lua_WindowUtil.openWin("Lua_AnnouncementWindow", Lua_WinParam.ACTION_OPEN, DataCenter.loginData.announcementObj);
    end
end

function Lua_LoginProxy:onPaltformLoginBack()
    local formData = {
        v = PragramVersion.SHOW_VERSION,
        package = ServerConfig.market,
        device = ServerConfig.device,
        sys_model = ServerConfig.sysModel,
        sys_version = ServerConfig.sysVersion,
        pefix_ext = DataCenter.sdkInterface.login_token, -- sdk登录授权信息全部存这里
        uid = ServerConfig.userID,
        password = PlayerPrefsUtil.instance:GetString(SetUpDefine.PASSWORD, "")
    };
    local tokenstr = decodeTabToJson(formData);
    UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestLoginStr, tokenstr, self, self.onLoadServerListCallBack, self.onLoadServerListError, true);
end

function Lua_LoginProxy:onLoadServerListCallBack(text)
    if strIsNullOrEmpty(text) then
        print("onLoadServerListCallBack text is nil");
        local tipsData = { des = LanUtil.formateStr(380026, LanUtil.getValue(380027)), btnType = 4 };
        Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return;    
    end

    local data = decodeJson(text);
    if data == nil then
        print("onLoadServerListCallBack decodeJson err:", text);
        local tipsData = { des = LanUtil.formateStr(380026, LanUtil.getValue(380028)), btnType = 4 };
        Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return;
    end

    local code = data.code;
    if code ~= nil and code ~= 1 then
        print("onLoadServerListCallBack", code, data.msg);
        if code == -1 then -- 账号未注册
            OperateAlert.showLangValue(380025);
            return;
        end

        -- 其他具体错误信息
        local msg = data.msg == nil and "" or data.msg;
        local tipsData = { des = LanUtil.formateStr(380024, msg, tostring(code)), btnType = 4 };
        Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return;
    end

    local user = data.user;
    if user ~= nil then
        local is_verify = user.is_verify;
        if is_verify ~= nil and is_verify == 0 then -- 未实名
            print("onLoadServerListCallBack 未实名", is_verify);
            local tipsData = { titleAtlas = "login_atlas", titleSprite = "ui_fcm_title_01", des = LanUtil.getValue(380023), btnType = 4 };
            Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
            return;
        end

        local age = user.age;
        if age ~= nil and age < Lua_CommonUtil.getCommonConfig("age_limit", 1, 18) then -- 未成年
            print("onLoadServerListCallBack 未成年", age);
            local tipsData = { titleAtlas = "login_atlas", titleSprite = "ui_fcm_title_01", des = LanUtil.getValue(380002), btnType = 4 };
            Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
            return;
        end
    end

    -- 无大区或者服务器列表
    if data.zone == nil or data.server == nil then
        print("onLoadServerListCallBack err ", data.zone == nil, data.server == nil);
        local msg = (data.zone == nil) .. "、" .. (data.server == nil);
        local tipsData = { des = LanUtil.formateStr(380026, msg), btnType = 4 };
        Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return;
    end

    local serverData = Lua_ServerListData.new();
    serverData:readFromJson(data)
    if not Lua_WindowUtil.isWindowShowing("Lua_ServerSelectWindow") then -- 未开选服界面
        local selectedServer = serverData:getAutoLoginServer();
        if selectedServer ~= nil then -- 新账号，没有角色直接进入默认推荐服务器进行创角
            self:onLoginServerGate(selectedServer);
            serverData.clean();
            return;
        end
    end

    -- 打开选服
    Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_OPEN, serverData);
end

function Lua_LoginProxy:onLoadServerListError(text)
    print("onLoadServerListError", text);
    if text == nil then text = "loadServerListError"; end
    local tipsData = { des = LanUtil.formateStr(380026, text), btnType = 4 };
    Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_LoginProxy:onLoginServerGate(selectedServer)
    local gatewayIP = "192.168.18.74"; -- 游戏网关IP，由中央服务器列表分配，切不可擅自改写，由这个ip去10700101验证返回正确的ip
    local gatewayPort = 6010; -- 网关端口，服务端分配，切不可擅自改写
    if hostname == nil or hostname == "" then
        gatewayIP = selectedServer.server_addr;
    else
        local str = ConnectionManager.getInstace():decodeServerAddresses(hostname);
        if str == nil or str == "" then
            gatewayIP = selectedServer.server_addr;
        else
            gatewayIP = str;
            local val = ConnectionManager.getInstace():isIPv4(hostname);
            if val == 1 then
                SDKInfo.isIPv4 = true;
            elseif val == 0 then
                SDKInfo.isIPv4 = false;
            end
        end
    end

    gatewayPort = selectedServer.server_port;
    ServerConfig.flag = selectedServer.sign;
    ServerConfig.time = tostring(selectedServer.tick);
    ServerConfig.sign = selectedServer.flag;
    ServerConfig.serverId = selectedServer.sort;
    ServerConfig.serverName = selectedServer.name;
    ServerConfig.real_server_name = selectedServer.real_server_name;
    ServerConfig.serverResRoot = selectedServer.resRoot;
    ConnectionManager.getInstace():connectionSocket(Connection.VALIDATION_SOCKET, gatewayIP, gatewayPort, true, true);
end

-- 所有配置加载完成
function Lua_LoginProxy:onConfigLoaded()
    GlobalVar.isInGame = 1;
    GlobalVar.bConfigLoaded = true;
    DataCenter.bConfigLoaded = true;-- 配置加载完成
    GlobalVar.bHandleServerMsg = true;
    DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.EnterGame);
    Lua_ProxyManager.getProxy("Lua_RoleProxy"):updateRoleInfo();-- 更新角色信息
    DataCenter.loginData:preLoadGameRes();
end

-- 屏幕适配
function Lua_LoginProxy:onScreenResize()
    -- if DataCenter.loginData.isInGame and GlobalVar.screenOffsetTopH > 0 or GlobalVar.screenOffsetBottomH > 0 then
    --     Lua_WindowUtil.openWin("Lua_LiuHaiMaskWindow", Lua_WinParam.ACTION_OPEN);
    -- end
    ThingUtil.instance:updateHeadBoard(0, -1);
    Lua_MsgUtil.callFunc("SCREEN_RESIZE_LUA");
end

-- 重连
function Lua_LoginProxy:onReconnect()
    if DataCenter == nil then
        return;
    end

    if DataCenter.bConfigLoaded then
        clearLua(true);
    end
end

function Lua_LoginProxy:onRunInBackgroundChange(obj)
    if GlobalVar.isInGame == 0 then
        return;
    end

    -- 程序后台运行状态变化, 0正常运行状态，1后台运行状态
    local stateVal = tonumber(tostring(obj));
    DataCenter.loginData:updateRunStateChange(stateVal);
end

-- 加载背景显示完成
function Lua_LoginProxy:onLoadingScreenShow(str)
    if DataCenter.loginData.bStartLoadEnterGame then -- 进入游戏世界中
        Lua_WindowUtil.openWin("Lua_StartWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_LoginWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_ServerListWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("LoginBgWindow", Lua_WinParam.ACTION_CLOSE);
        DataCenter.loginData.bShowVideoFrame = true;
        DataCenter.loginData:clearChcekVideo();
        DataCenter.loginData:checkEnterGame();
        if str ~= nil and str == DataCenter.loginData.videoSign then
            DataCenter.loginData:loadMainSec();
        end
    end
end

-- 加载界面关闭
function Lua_LoginProxy:onLoadingScreenHide(str)
    print("onLoadingScreenHide", DataCenter.loginData.bStartLoadEnterGame, str)
    if DataCenter.loginData.videoSign ~= nil and str == DataCenter.loginData.videoSign then
        if not DataCenter.loginData.bShowVideoFrame then -- 非正常播放视频关闭视频加载页
            return;
        end
        DataCenter.loginData.isEnterGameWorld = true;
    end
    
    if DataCenter.loginData.bStartLoadEnterGame then -- 进入游戏世界中
        DataCenter.loginData.bStartLoadEnterGame = false;
        if DataCenter.loginData.isCreateRole then
            DataCenter.loginData:onEnteredInit();
        end
    end
end

-- 视频播放资源出错
function Lua_LoginProxy:onVideoResErr(str)
    if DataCenter.loginData.videoSign ~= nil and str == DataCenter.loginData.videoSign then
        if not DataCenter.loginData.bShowVideoFrame then -- 非正常播放视频关闭视频加载页
            DataCenter.loginData:clearChcekVideo();
            DataCenter.loginData:onCheckVideo();
        end
    end
end

-- 单服更新完成
function Lua_LoginProxy:onSingleSerUpdateEnd()
    DataCenter.loginData:onServerUpdateEnd();
end

function Lua_LoginProxy:onEnterGameScene()
    -- DataCenter.loginData:enterGameScene();
end

-- 重连成功
function Lua_LoginProxy:onReconnectSuccess()
    if DataCenter == nil then
        return;
    end

end

-- 显示log
function Lua_LoginProxy:onShowLogChange()
    GlobalVar.mustShowLog = not GlobalVar.mustShowLog;
end

-- 显示fps
function Lua_LoginProxy:onShowFps(bShow)
    LuaUtil.showFps(bShow);
end

function Lua_LoginProxy:onSceneLoaded(sceneId)
    if DataCenter.loginData.waitShowScene == sceneId then
        DataCenter.loginData:completeEnterGame();
    end
end

function Lua_LoginProxy:onEscClick()
    if DataCenter == nil then
        return;
    end

    if not DataCenter.loginData.isInGameWorld then -- 未进入游戏场景
        return;
    end

    if Lua_PlatformUtil.IsAndroid() == true or Lua_PlatformUtil.IsIPhonePlayer() == true then
        DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.Exit);
    elseif not Lua_WindowUtil.isWindowShowing("Lua_TipsWindow") then
        local tipsData = { layer = Lua_MainWinDefine.MAX_TOP_LAYER, des = LanUtil.getValue(300019), btnType = 1, owner = self, sureFun = self.onReLogin };
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
    end
end

function Lua_LoginProxy:onReLogin()
    LoadManager.getInstance():Load(Lua_LoadFileType.IMG, "/images/loading/login_bg.jpg", nil, nil, nil, nil, 999, 30);
    LuaUtil.relogin();
end








---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 上行
-- 随机名
function Lua_LoginProxy:onRandomName(sex) 
    local cmd = ProtoPublic_pb.Proto10100002();
    cmd.sex = sex;
    sendMsg(10100002, cmd);
end

-- 登录角色
function Lua_LoginProxy:loginRole(roleId)  
    if GlobalVar.reconnect == 1 then -- 重连
        local cmd = ProtoPublic_pb.Proto10100007();
        cmd.role_id = roleId;
        sendMsg(10100007, cmd);
    else
        DataCenter.loginData.isUpdatePlayerInfo = false;
        local cmd = ProtoPublic_pb.Proto10100004();
        cmd.role_id = roleId;
        sendMsg(10100004, cmd);
    end
end

-- 创角
function Lua_LoginProxy:sCreateRole(nameStr, sex)
    local cmd = ProtoPublic_pb.Proto10100003();
    cmd.name = nameStr;
    cmd.sex = sex;
    cmd.career = 1;
    sendMsg(10100003, cmd);
end

-- 请求预创角色
function Lua_LoginProxy:sAdvCreateRole()
    sendMsg(10100008);
end











---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 下行
-- 网关验证返回
function Lua_LoginProxy:gatewayValReturn(mp)
    if mp.errno == 0 then
        local con = ConnectionManager.getInstace():getConnection(Connection.VALIDATION_SOCKET);
        if con:isConnect() == true then
            ConnectionManager.getInstace():closeConnenction(Connection.VALIDATION_SOCKET);
        end

        local msg = ProtoPublic_pb.Proto50100101();
        msg:ParseFromString(mp.data);
        local hostname = msg.domain;
        if LanUtil.IsNullOrEmpty(hostname) ~= true then
            local str = ConnectionManager.getInstace():decodeServerAddresses(hostname);
            if str == nil or str == "" then
                ServerConfig.single_server = hostname;
            else
                ServerConfig.single_server = str;
                local val = ConnectionManager.getInstace():isIPv4(hostname);
                if val == 1 then
                    SDKInfo.isIPv4 = true;
                elseif val == 0 then
                    SDKInfo.isIPv4 = false;
                end
            end
        else
            ServerConfig.single_server = msg.domain;
        end

        -- 连接主socket
        ServerConfig.single_port = msg.port;
        PlayerPrefsUtil.instance:SetString(SetUpDefine.SELECT_SERVER, ServerConfig.sign);
        ConnectionManager.getInstace():connectionSocket(Connection.MAIN_SOCKET, ServerConfig.single_server, ServerConfig.single_port, true, true);
    end
end

-- 随机名字返回
function Lua_LoginProxy:rRandomName(mp)
    if mp.errno ~= 0 then 
        return;
    end

    local msg = ProtoPublic_pb.Proto50100002();
    msg:ParseFromString(mp.data);
    Lua_MsgUtil.callFunc("BACK_RANDOM_NAME", msg.name);
end

-- 登录服务器
function Lua_LoginProxy:rLoginServer(mp)
    if mp.errno ~= 0 then 
        return;
    end

    local msg = ProtoPublic_pb.Proto50100001();
    msg:ParseFromString(mp.data);
    if msg.role_list ~= nil and #msg.role_list > 0 then -- 有角色
        DataCenter.loginData.isCreateRole = true;
        DataCenter.loginData.bShowVideoFrame = true;
        Lua_WindowUtil.openWin("Lua_StartWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_LoginWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_CLOSE);
        self:loginRole(msg.role_list[1].role_id);
    else -- 预创角
        DataCenter.loginData.isCreateRole = false;
        DataCenter.loginData.bShowVideoFrame = false;
        DataCenter.loginData.bLoadingVideoType = true; -- 未创角用视频加载，已有角色用进度加载
        self:sAdvCreateRole();

        Lua_WindowUtil.openWin("Lua_StartWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_LoginWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_CLOSE);
    end
end

function Lua_LoginProxy:rCreateRole(mp)
    if mp.errno ~= 0 then 
        if DataCenter.loginData.isCreateRole then
            Lua_WindowUtil.openWin("Lua_CreateRoleWindow", Lua_WinParam.ACTION_CLOSE);
        end
        return;
    end

    Lua_WindowUtil.openWin("Lua_CreateRoleWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_StartWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_LoginWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_ServerListWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_ServerSelectWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("LoginBgWindow", Lua_WinParam.ACTION_CLOSE);

    local msg = ProtoPublic_pb.Proto50100003();
    msg:ParseFromString(mp.data);
    DataCenter.roleData.name = msg.role_name;
    DataCenter.roleData.createRoleTime = tonumber(tostring(msg.create_tick));
    DataCenter.loginData.isCreateRole = true;
    DataCenter.gameReported:UpdateCreateRole();
    DataCenter.loginData:onEnteredInit();
    DataCenter.guideData:checkGuide(); 
    DataCenter.guideData:checkPlayGuide();
end

function Lua_LoginProxy:rLoginRole(mp)
    if mp.errno == 0 then 
        return;
    end

    local tipsDes = 0;
    local errCode = mp.errno;
    print("rLogin   ErrorCode = ", errCode);
    if errCode == -1021 then -- 异地登录
        tipsDes = 123630;
        GlobalVar.canReconnect = false;
        DataCenter.loginData:clearHeart();
    elseif errCode == -1010 then -- 账号在线(暂时废弃,不触发)
        tipsDes = 123631;
    end

    if tipsDes ~= 0 then
        local tipsData = { des = LanUtil.getValue(tipsDes), btnType = 4, sureLabel = LanUtil.getValue(10008), owner = self, sureFun = self.doReLogin };
        Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
    end
end

function Lua_LoginProxy:doReLogin()
    ConnectionManager.getInstace():loginOut();
end

function Lua_LoginProxy:rTopNumber(mp)
    if mp.errno == 0 then
        GlobalVar.canReconnect = false;
        DataCenter.loginData:clearHeart();
        
        Lua_WindowUtil.openWin("ReconnectingWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("ReconnectWindow", Lua_WinParam.ACTION_CLOSE);

        local tipsData = { des = LanUtil.getValue(123630), btnType = 4, sureLabel = LanUtil.getValue(10008), owner = self, sureFun = self.doReLogin };
        Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
    end
end

-- 获取服务器信息
function Lua_LoginProxy:rServerInfo(mp)
    local msg = ProtoPublic_pb.Proto50100005();
    msg:ParseFromString(mp.data);
    local t = tonumber(tostring(msg.time));
    DataCenter.roleData.serverTime = t;
    GlobalVar.cur_tick = t;
end

-- 心跳包
function Lua_LoginProxy:rHeart(mp)
    local msg = ProtoPublic_pb.Proto50100006();
    msg:ParseFromString(mp.data);
    local t = tonumber(tostring(msg.time));
    DataCenter.roleData.serverTime = t;
    GlobalVar.cur_tick = t;
end

-- 玩家登录信息返回
function Lua_LoginProxy:rUpdatePlayerInfo(mp)
    DataCenter.loginData:addHeart(); -- 心跳
    GlobalVar.bDisconnect = false;
    local isReconnect = GlobalVar.reconnect == 1;
    if isReconnect then -- 顶号情况采用重连：重连成功停止重连
        WindowMananger.getInstance():closeWinsExceptIgnore(nil); -- 重连成功关闭已打开窗口
        ConnectionManager.getInstace():stopReconnect();
        if GlobalVar.bConfigLoaded then
            Lua_MsgUtil.callFunc("RECONNECT_SUCCESS");
        end
    end

    if mp.errno ~= 0 then 
        return;
    end

    DataCenter.loginData:updatePlayerInfo(mp, isReconnect);
end

function Lua_LoginProxy:rLoginServerFail(mp)
    local errCode = mp.errno;
    if errCode ~= 0 then
        local errStr = LuaUtil.getErrCodeStr(errCode);
        if strIsNullOrEmpty(errStr) then errStr = LanUtil.getValue(380031) .. errCode; end
        local tipsData = { des = errStr, btnType = 4, sureFun = self.onReLoginGame };
        Lua_WindowUtil.openWin("Lua_LoginTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
    end
end

function Lua_LoginProxy:onReLoginGame()
    LuaUtil.relogin();
end