-- 登录Tips ESC后退键不会被关闭 热更机制采用独立界面独立代码
Lua_LoginTipsWindow = class("Lua_LoginTipsWindow", Lua_Window)
function Lua_LoginTipsWindow:ctor()
	self:superCall("ctor")

	self.w = 703
	self.h = 473
	self.layer = MainWinDefine.TIPS_WINDOW_LAYER
	self.windowName = "Lua_LoginTipsWindow"
	self.showBlackMask = true
	self.showWinBg = true
	self.winBgAtlas = "common_altas_1"
	self.winBgSprite = "ui_common_window_007"
	self.winBgPosX = 0
	self.winBgPosY = 8
	self.showTitle = true
	self.titleNameOffsetY = -37.5
	self.showClose = true
	self.btnCloseOffsetY = -37.5
end

function Lua_LoginTipsWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.titleName:addLoadCompleteFun(self, self.onTitleNameLoaded)

	local half_h = self.h / 2

	self.lineImg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_line_003", 0, -half_h + 136.5, 637, 17)

	self.btnCancal = UICreate.createButton(self.content, LanUtil.getValue(105029), -145, -half_h + 84.5, 177, 58)
	self.btnCancal:setStyle(3)
	self.btnCancal:addClickFuntion(self, self.onBtnCancalClick)

	self.btnSure = UICreate.createButton(self.content, LanUtil.getValue(105029), 145, -half_h + 84.5, 177, 58)
	self.btnSure:setStyle(1)
	self.btnSure:addClickFuntion(self, self.onBtnSureClick)

	self.des = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 24)
	self.des.pivotValue = 4
	self.des.alignmentValue = 4
	self.des.horizontalOverflowValue = 1
	self.des.verticalOverflowValue = 1
	self.des.colorStr = Lua_ColorDefine.transColorStr("846651")
end

function Lua_LoginTipsWindow:dispose()
	self:cleanShowData()
	self:superCall("dispose")
end

function Lua_LoginTipsWindow:showWin(param)
	self:superCall("showWin", param)
	self:updateShowInfo()
end

function Lua_LoginTipsWindow:onTitleNameLoaded()
	self:createTitleDeco()
end

function Lua_LoginTipsWindow:updateShowInfo()
	if self.showData.titleAtlas and self.showData.titleSprite then
		self.titleName:setAltas(self.showData.titleAtlas, self.showData.titleSprite)
	else
		self.titleName:setAltas("common_altas_3", "ui_hy_title_02")
	end
	self.titleName:resetSize()

	self.des.text = self.showData.des
	self.des:resetSize()

	local width = self.showData.width == nil and self.w - 103 or self.showData.width
	local height = self.showData.height == nil and 31 or self.showData.height
	if self.des.width >= width then
		self.des.alignmentValue = 3
		self.des.horizontalOverflowValue = 0
		self.des:SetDimensions(width, height)
	end

	local posX = self.showData.posX == nil and 0 or self.showData.posX
	local posY = self.showData.posY == nil and 30 or self.showData.posY
	self.des:setLocation(posX, posY, 0)

	if self.showData.btnType == 1 then
		self.btnCancal:setEnable(true)
		self.btnSure:setEnable(true)
		self.btnCancal.label = self.showData.cancelLabel == nil and LanUtil.getValue(10016) or self.showData.cancelLabel
		self.btnSure.label = self.showData.sureLabel == nil and LanUtil.getValue(105029) or self.showData.sureLabel
		self.btnClose:setEnable(true)
		self.isClickClose = true
	elseif self.showData.btnType == 2 then
		self.btnCancal:setEnable(false)
		self.btnSure:setEnable(true)
		self.btnSure.label = self.showData.sureLabel == nil and LanUtil.getValue(105029) or self.showData.sureLabel
		self.btnSure:setLocation(0, -(self.h / 2 - 82.5), 0)
		self.btnClose:setEnable(true)
		self.isClickClose = true
	elseif self.showData.btnType == 3 then
		self.btnCancal:setEnable(false)
		self.btnSure:setEnable(false)
		self.btnClose:setEnable(false)
		self.isClickClose = false
	elseif self.showData.btnType == 4 then
		self.btnCancal:setEnable(false)
		self.btnSure:setEnable(true)
		self.btnSure.label = self.showData.sureLabel == nil and LanUtil.getValue(105029) or self.showData.sureLabel
		self.btnSure:setLocation(0, -(self.h / 2 - 82.5), 0)
		self.btnClose:setEnable(false)
		self.isClickClose = false
	else
		self.btnCancal:setEnable(false)
		self.btnSure:setEnable(false)
		self.btnClose:setEnable(true)
		self.isClickClose = true
	end
end

function Lua_LoginTipsWindow:cleanShowData()
	if self.showData ~= nil then
		self.showData.owner = nil
		self.showData.cancelFun = nil
		self.showData.sureFun = nil
		self.showData = nil
	end
end

function Lua_LoginTipsWindow:onBtnCancalClick(go)
	if self.showData ~= nil and self.showData.cancelFun ~= nil then
		self.showData.cancelFun(self.showData.owner, self.showData)
	end
	self:hide()
end

function Lua_LoginTipsWindow:onBtnSureClick(go)
	if self.showData ~= nil and self.showData.sureFun ~= nil then
		self.showData.sureFun(self.showData.owner, self.showData)
	end
	self:hide()
end