-- 界面缓动动画控制器
checkRequire("Lua_UITweenConfigData");
Lua_WinTweenManager = class("Lua_WinTweenManager");
function Lua_WinTweenManager:ctor()
    self:removAllWinTween();
end

function Lua_WinTweenManager:dispose()
    self:removAllWinTween();
end

function Lua_WinTweenManager:removAllWinTween()
    self.tweenDic = {};
    self.tween_index = 0;
end

-- 移除界面动画
function Lua_WinTweenManager:removeWinTween(index)
    if index ~= nil and self.tweenDic[index] ~= nil then
        local arr = self.tweenDic[index];
        while arr:getSize() > 0 do
            TweenUtil.getInstance():stop(arr:remove());
        end
        self.tweenDic[index] = nil;
    end
end

-- 创建界面动画
function Lua_WinTweenManager:createWinTween(winName, tf)
    if tf == nil then
        return;
    end

    local winData = Lua_WinConfigData.getConfigData(winName);
    if winData ~= nil and winData.tweenId ~= nil and #winData.tweenId > 0 then
        local tweenList = Array();
        for i = 1, #winData.tweenId do
            local obj = self:playWinTween(winData.tweenId[i], tf);
            if obj ~= nil then
                tweenList:add(obj);
            end
        end

        if tweenList:getSize() > 0 then
            self.tween_index = self.tween_index + 1;
            self.tweenDic[self.tween_index] = tweenList;
            return self.tween_index;
        end
    end
    return nil;
end

-- 播放界面动画
function Lua_WinTweenManager:playWinTween(tweenId, tf)
    if tweenId == nil or tf == nil then
        return nil;
    end

    local tweenData = Lua_UITweenConfigData.getConfigData(tweenId);
    if tweenData == nil or tweenData.ui_object == nil then
        return nil;
    end

    local arr = tweenData.uiObjectArr;
    if arr == nil then
        return nil;
    end

    local len = arr:getSize()
    local count = tf.childCount;
    local tempCount = 1;
    local index = tf.name == arr[1] and 2 or 1;
    local sub;
    while index <= len and tempCount <= count do
        sub = tf:GetChild(tempCount - 1);
        tempCount = tempCount + 1
        if arr[index] ~= nil and sub ~= nil and sub.name == arr[index] then
            count = tf.childCount;
            index = index + 1;
            tempCount = 1;
            tf = sub;
        end
    end

    if index >= len and tf.gameObject.name == arr[len] then
        self:playWinTweenByObj(tf.gameObject, tweenId, tweenData);
        return tf.gameObject;
    end
    return nil;
end

-- 播放界面动画
function Lua_WinTweenManager:playWinTweenByObj(obj, tweenId, tweenData)
    if obj == nil then
        return;
    end

    if tweenData == nil then
        if tweenId == nil then
            return;
        end

        tweenData = Lua_UITweenConfigData.getConfigData(tweenId);
        if tweenData == nil then
            return;
        end
    end

    if tweenData.startPosTab ~= nil then
        LuaUtil.setObjPos(obj, tweenData.startPosTab[1], tweenData.startPosTab[2], tweenData.startPosTab[3]);
    end

    if tweenData.startRotTab ~= nil then
        LuaUtil.setObjRot(obj, tweenData.startRotTab[1], tweenData.startRotTab[2], tweenData.startRotTab[3]);
    end

    if tweenData.startScaleTab ~= nil then
        LuaUtil.setObjScale(obj, tweenData.startScaleTab[1], tweenData.startScaleTab[2], 1);
    end

    if tweenData.needGradient then
        TweenUtil.getInstance():addTweenTargetAlpha(obj, tweenData.keepTime, tweenData.delayTime, -1, true);
    end

    local px;
    local py;
    local pz;
    local targetPos = tweenData.targetPosTab;
    if targetPos == nil or #targetPos == 0 then
        local anchoredPosition3D = obj.transform.anchoredPosition3D;
        px = anchoredPosition3D.x;
        py = anchoredPosition3D.y;
        pz = anchoredPosition3D.z;
    elseif #targetPos > 2 then
        px = targetPos[1];
        py = targetPos[2];
        pz = targetPos[3];
    elseif #targetPos == 2 then
        px = targetPos[1];
        py = targetPos[2];
        pz = obj.transform.anchoredPosition3D.z;
    elseif #targetPos == 1 then
        px = targetPos[1];
        local anchoredPosition3D = obj.transform.anchoredPosition3D;
        py = anchoredPosition3D.y;
        pz = anchoredPosition3D.z;
    end
    local targetRot = tweenData.targetRotTab;
    local targetScale = tweenData.targetScaleTab;
    TweenUtil.getInstance():addTween(obj, tweenData.keepTime, tweenData.delayTime, 
        px, py, pz, 
        targetRot[1], targetRot[2], targetRot[3], 
        targetScale[1], targetScale[2], 1,
        nil, nil, tweenData.offect, false);
end