Lua_MsgUtil = {};
Lua_MsgUtil.dic = {};
Lua_MsgUtil.key = 0;
function Lua_MsgUtil.callFunc(name, data)
	local arr = Lua_MsgUtil.dic[name];
	if arr ~= nil then
		local len = arr:getSize();
		for i=1,len do
			if arr[i] ~= nil and arr[i].isDispose ~= true then
				local owner = arr[i].owner;
				if owner ~= nil and owner.skinBuilded ~= nil and owner.windowName ~= nil then
					if owner.skinBuilded ~= true then -- 延迟创建
						Lua_MsgUtil.addDelayCall(owner, arr[i].func, data);
					else
						arr[i].func(owner, data);
					end
				else
					arr[i].func(owner, data);
				end	
			end
		end
	end
end

function Lua_MsgUtil.addDelayCall(owner, func, data)
	if owner == nil or func == nil then
		return;
	end

	-- 非窗口类
	local windowName = owner.windowName;
	if windowName == nil or windowName == "" then
		return;
	end

	if Lua_MsgUtil.delayCallDic == nil then
		Lua_MsgUtil.delayCallDic = {};
	end
	
	if Lua_MsgUtil.delayCallDic[windowName] == nil then
		Lua_MsgUtil.delayCallDic[windowName] = Array();
	end
	Lua_MsgUtil.delayCallDic[windowName]:add({data = data, func = func, owner = owner});
end

function Lua_MsgUtil.callDelayFuns(windowName)
	if Lua_MsgUtil.delayCallDic == nil or Lua_MsgUtil.delayCallDic[windowName] == nil then
		return;
	end

	local arr = Lua_MsgUtil.delayCallDic[windowName];
	while arr:getSize() > 0 do
		local obj = arr:remove();
		if obj ~= nil then
			obj.func(obj.owner, obj.data);
			obj.func = nil;
			obj.owner = nil;
			obj.data = nil;
			obj = nil;
		end
	end
	arr:dispose();
	arr:clear();
	arr = nil;
	Lua_MsgUtil.delayCallDic[windowName] = nil;
end

function Lua_MsgUtil.clearDelayFuns(windowName)
	if Lua_MsgUtil.delayCallDic == nil or Lua_MsgUtil.delayCallDic[windowName] == nil then
		return;
	end

	local arr = Lua_MsgUtil.delayCallDic[windowName];
	while arr:getSize() > 0 do
		local obj = arr:remove();
		if obj ~= nil then
			obj.func = nil;
			obj.owner = nil;
			obj.data = nil;
			obj = nil;
		end
	end
	arr:dispose();
	arr:clear();
	arr = nil;
	Lua_MsgUtil.delayCallDic[windowName] = nil;
end

function Lua_MsgUtil.traceListenerList()
	print("----------------------");
	for k, v in pairs(Lua_MsgUtil.dic) do
		print(k, v:getSize())
	end
end

function Lua_MsgUtil.hasEventListener(name, owner, func)
	local arr = Lua_MsgUtil.dic[name];
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do
			if arr[i].owner == owner and arr[i].func == func then
				return true;
			end
		end
	end
	return false;
end

function Lua_MsgUtil.addEventListener(name, owner, func)
	local has = Lua_MsgUtil.hasEventListener(name, owner, func);
	if has == true then
		return false;
	end
	
	local arr = Lua_MsgUtil.dic[name];
	if arr == nil then
		arr = Array();
		Lua_MsgUtil.dic[name] = arr;
	end
	Lua_MsgUtil.key = Lua_MsgUtil.key + 1;
	arr:add({key = Lua_MsgUtil.key, func = func, owner = owner});
	return true;
end

function Lua_MsgUtil.removeEventListener(name, owner, func)
	local arr = Lua_MsgUtil.dic[name];
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do
			if arr[i].owner == owner and arr[i].func == func then
				arr[i].owner = nil;
				arr[i].func = nil;
				arr[i].isDispose = true;
				break;
			end
		end
	end
end

function Lua_MsgUtil.checkRemoveEvent()
	if Lua_MsgUtil.time == nil or DataCenter.frameStartTime - Lua_MsgUtil.time > 0.5 then
		Lua_MsgUtil.time = DataCenter.frameStartTime;
		for k, v in pairs(Lua_MsgUtil.dic) do
			local len = v:getSize();
			while (len > 0) do
				local item = v[len];
				if item ~= nil and item.isDispose == true then
					v:remove(len);
				end
				len = len - 1;
			end

			if v:getSize() == 0 then
				Lua_MsgUtil.dic[k] = nil;
			end
		end
	end
end

function Lua_MsgUtil.clearAllFun()
	if Lua_MsgUtil.delayCallDic ~= nil then
		for winName, arr in pairs(Lua_MsgUtil.delayCallDic) do
			while arr:getSize() > 0 do
				local obj = arr:remove();
				if obj ~= nil then
					obj.owner = nil;
					obj.data = nil;
					obj.func = nil;
					obj = nil;
				end
			end
			arr:dispose();
			arr:clear();
			arr = nil;
			Lua_MsgUtil.delayCallDic[winName] = nil;
		end
		Lua_MsgUtil.delayCallDic = nil;
	end

	for k, arr in pairs(Lua_MsgUtil.dic) do
		while arr:getSize() > 0 do
			local obj = arr:remove();
			if obj ~= nil then
				obj.owner = nil;
				obj.key = nil;
				obj.func = nil;
				obj = nil;
			end
		end
		arr:dispose();
		arr:clear();
		arr = nil;
		Lua_MsgUtil.dic[k] = nil;
	end
	Lua_MsgUtil.dic = {};
	Lua_MsgUtil.clearCSharpEventAct();
end